// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Human.cpp
// -The definitions of the Human class

#include <algorithm>
#include <iostream>  // temp_test
#include <iterator>

#include "Human.hpp"

// using std::cbegin;
using std::begin;
using std::end;
using std::find;

//------------------------------------------------------------------------------
Human::Human(std::string const& name, Groups const& groups)
    : name{name}, groups{groups} {
  // Validate one -- and __only__ one -- Master for robowaifu.
  // -UD: Later, this will be part of a secured system start-up
  // sequence, and  not merely a general Human ctor assignment.
  //
  // Discover if this Human is The Master
  if (auto it = find(begin(groups), end(groups), Relation::master);
      it != end(groups)) {
    // test:
    std::cout << "Found 'The_Master'\n";

    // TODO: validate there have been no other 'The_Master' assignments first
    //

    // Found it, assign this object's pointer to the static
    // rw::The_Master = std::make_unique<Human>(this);
  }

  // TODO:
  // Validate that the Human is included within at least __one__ group
  // (non-empty) 'groups' param.
}

//------------------------------------------------------------------------------
std::string Human::human() const noexcept {
  return name;
}

//------------------------------------------------------------------------------
Groups Human::relations() const noexcept {
  return groups;
}

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
