// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Human.hpp
// -The declarations interface of the Human class

#pragma once

#include <memory>
#include <string>

#include "utility.hpp"

using std::string;

/** Represents Human entities within robowaifu's world. */
class Human {
 public:
  // Human() {}
  /** Basic ctor
   * @param name [IN] the name for the Human
   * @param groups [IN] the container of Relation's (groups) the Human is within
   */
  Human(std::string const& name, Groups const& groups);

  /** @return the Human's common name */
  std::string human() const noexcept;

  /** @return the container of Relation's to robowaifu's Master */
  Groups relations() const noexcept;

 private:
  string name;
  Groups groups;
};

namespace rw {

/** The one -- and @b only one -- robowaifu's Master */
static std::unique_ptr<Human> The_Master = nullptr;

}  // namespace rw

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
