// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Info.hpp
// -The declarations interface of the Info class

#pragma once

#include <string>

#include "Human.hpp"
#include "utility.hpp"

using std::string;

/** Represents a piece of information, with associated ownership & group share
 * permissions embedded */
class Info {
 public:
  /** Basic ctor
   * @param data [IN] the information data load
   * @param owner [IN] the Human in control of the info
   * @param permits [IN] the container of Relation's this Info is authorized for
   */
  Info(std::string const& data, Human const& owner, Permit const& permits);

  /** @return the Info's data load */
  std::string info() const noexcept;

  /** @return the container of Relation's this info is authorized for */
  Permit allows() const noexcept;

 private:
  string data;
  Human  owner;
  Permit permits;
};

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
