// robowaifu access control
// ========================
// -The software testbed for devising access control systems for robowaifus

// -Filename: Inquiry.hpp
// -The declarations interface of the Inquiry class

#pragma once

#include "Human.hpp"
#include "Info.hpp"
#include "utility.hpp"

/** Represents a question by a Human regarding Info */
class Inquiry {
 public:
  /** Basic ctor
   * @param human [IN] the Human asking the question
   * @param info [IN] the Info being requested
   */
  Inquiry(Human const& human, Info const& info);

  /** @return the Inquiry's Human 'asker' */
  Human who() const noexcept;

  /** @return the Inquiry's Info datum */
  Info what() const noexcept;

 private:
  Human human;
  Info  info;
};

// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
